import { Component, Prop, h, State } from '@stencil/core';
import Call from '../../call.svg';
import ActiveCall from '../../active-call.svg';
import CallBox from '../../call-box.svg';
import Close from '../../close.svg';
import Hooray from '../../hooray.svg';
import Error from '../../error.svg';
import Oh from '../../oh.svg';
export class MyComponent {
  constructor() {
    this.logo = false;
    this.dialogStatus = false;
    this.step = "start";
    this.token = "";
    this.value = "";
  }
  /**
   * The middle name
   */
  componentWillLoad() {
    const checkAuth = async () => {
      try {
        const result = await fetch('http://165.227.180.82:8005/api/auth', {
          method: 'POST',
          headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json',
          },
          body: JSON.stringify({
            "api_key": 'X4HBLJ458L5NGYL43KB6EUZFOLUJ1ANU7OWEH5YR',
            "api_secret": '471IN7Y2E28PU7XNG14J9A6YC669S0RHLNUOXEDTT5TESJPPTSZ2KH5H4NA85TRP'
          })
        });
        const response = await result.json();
        this.token = response.token;
      }
      catch (err) {
        console.log(err);
      }
    };
    checkAuth();
  }
  async call() {
    if (!this.value) {
      return;
    }
    try {
      this.step = "progress";
      const callResponse = await fetch(' http://165.227.180.82:8005/api/feature/click2call', {
        method: 'POST',
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/json',
          "x-api-session-token": this.token,
        },
        body: JSON.stringify({ "destination_phone": this.value, "queue": "sales" })
      });
      const { status } = await callResponse.json();
      this.step = status ? "done" : "error";
      this.value = "";
      setTimeout(() => {
        this.step = "start";
      }, 3000);
    }
    catch (error) {
      this.step = "error";
      setTimeout(() => {
        this.step = "start";
      }, 3000);
    }
  }
  handleChange(event) {
    this.value = event.target.value;
  }
  mouseOverLogo() {
    this.logo = true;
  }
  mouseDownLogo() {
    this.logo = false;
  }
  showDialog() {
    this.dialogStatus = true;
    this.logo = false;
  }
  closeDialog() {
    this.dialogStatus = false;
  }
  render() {
    if (!this.token) {
      return null;
    }
    let dialog;
    if (this.step == "start") {
      dialog = (h("div", { class: "call-box-detail" },
        h("img", { src: CallBox, width: "70", height: "70" }),
        h("h4", null, "Want to know more?"),
        h("p", null, "Please enter your phone number and we will call you back immediately"),
        h("input", { class: "call-input", value: this.value, onInput: (event) => this.handleChange(event) }),
        h("div", { class: "call-box active down", onClick: () => this.call() },
          h("div", { class: "call-text" }, "Call Me"),
          h("div", { class: "call-box-inside" },
            h("img", { src: ActiveCall, class: "call-box-logo" })))));
    }
    else if (this.step == "progress") {
      dialog = (h("div", { class: "call-box-detail" },
        h("img", { src: Error, width: "150" }),
        h("h4", null, "Connecting Please Hold on!")));
    }
    else if (this.step == "done") {
      dialog = (h("div", { class: "call-box-detail" },
        h("img", { src: Hooray, width: "50" }),
        h("h4", null, "Hooray!"),
        h("p", null, "You should receive a phone call from us in a while. It will be a pleasure to talk to you!")));
    }
    else {
      dialog = (h("div", { class: "call-box-detail" },
        h("img", { src: Oh, width: "50" }),
        h("h4", null, "Oh No!"),
        h("p", null, "It seems that we cannot connect with you right now, but don't worry, we will contact you really soon.")));
    }
    return (h("div", { class: "message" },
      this.dialogStatus ? (h("div", { class: "call-details" },
        h("img", { src: Close, class: "close", onClick: () => this.closeDialog() }),
        dialog)) : null,
      h("div", { class: `call-box ${this.logo ? 'active' : ''}` },
        this.logo ? h("div", { class: "call-text" }, "Call Me") : null,
        h("div", { class: "call-logo", onMouseOver: () => (!this.dialogStatus ? this.mouseOverLogo() : null), onMouseLeave: () => this.mouseDownLogo(), onClick: () => this.showDialog() },
          h("img", { src: this.logo ? ActiveCall : Call, class: "logo" })))));
  }
  static get is() { return "my-component"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["my-component.css"]
  }; }
  static get styleUrls() { return {
    "$": ["my-component.css"]
  }; }
  static get properties() { return {
    "first": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "The first name"
      },
      "attribute": "first",
      "reflect": false
    }
  }; }
  static get states() { return {
    "logo": {},
    "dialogStatus": {},
    "step": {},
    "token": {},
    "value": {}
  }; }
}
